

#include "stdafx.h"
#include "ScreenFrame.h"


bool ScreenFrame::MoveFrame(CDC* pDC, int x, int y)
{
	int nX = -x / SliceWidth;
	int nY = -y / SliceHeight;
	int offsX = x % SliceWidth;
	int offsY = y % SliceHeight;
	
	LoadFrame( nX, nY, FRAME_WIMDOW_WIDTH_COUNT, FRAME_WIMDOW_HEIGHT_COUNT);
	DrawFrames( pDC, offsX, offsY);

	return FALSE;
}

bool ScreenFrame::LoadSlice(CPicture *bmp, int nX, int nY)
{
	char str[128];
	int slice = nX * ( MAP_IMG_WIDTH / SliceWidth ) + nY + 1;	// +1 if picture start named from 1
	sprintf(str, "gif\\spbmap_%02d.gif", slice);
	bmp->Load(str);
	return FALSE;
}
/*
bool ScreenFrame::SliceInCashe(int slice, CPicture &bmp_cashed)
{
	CPicture bmp_cashed;
	int i, j;
	for( i=0; i < FRAME_WIMDOW_WIDTH_COUNT; i++)
		for( j=0; j < FRAME_WIMDOW_HEIGHT_COUNT; j++)
		{
			if(SliceLoaded[i][j] == slice)
			{
				bmp_cashed = bmp[i][j];
			}
		}
	return false;
}
*/

bool ScreenFrame::LoadFrame( int nX, int nY, int cX, int cY)
{
	int slice;
	char str[128];
	int i, j, x, y;

	for( i=0, x=nX; i < FRAME_WIMDOW_WIDTH_COUNT && x < (nX+cX); i++, x++)
		for( j=0, y=nY; j < FRAME_WIMDOW_HEIGHT_COUNT && y < (nY+cY); j++, y++)
		{
			slice = y * ( MAP_IMG_WIDTH / SliceWidth ) + x + 1;	// +1 if picture start named from 1
			if(SliceLoaded[i][j] != slice)
			{
				sprintf(str, "gif\\spbmap_%02d.gif", slice);
				bmp[i][j].Load(str);
			}
		}

	return FALSE;
}

bool ScreenFrame::DrawFrames(CDC* pDC, int offsetX, int offsetY)
{
	int i, j;

	for( i=0; i < FRAME_WIMDOW_WIDTH_COUNT; i++)
		for( j=0; j < FRAME_WIMDOW_HEIGHT_COUNT; j++)
		{
			bmp[i][j].Show(pDC, CRect(i*SliceWidth + offsetX, j*SliceHeight  + offsetY, 
				i*SliceWidth+SliceWidth + offsetX, j*SliceHeight+SliceHeight + offsetY));
		}

	return FALSE;
}

