

#if !defined(_SCREENFRAME__INCLUDED_)
#define _SCREENFRAME__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Picture.h"



#define MAP_IMG_WIDTH		6120
#define MAP_IMG_HEIGHT		8448

#define MAP_SLICE_WIDTH		255
#define MAP_SLICE_HEIGHT	255

#define FRAME_WIMDOW_WIDTH_COUNT	2
#define FRAME_WIMDOW_HEIGHT_COUNT	2



class ScreenFrame
{
public:
	ScreenFrame()
	{
		Width = 240;
		Height = 320;

		SliceWidth = MAP_SLICE_WIDTH;
		SliceHeight = MAP_SLICE_HEIGHT;
	
		OffsetX = 0;
		OffsetY = 0;

		isLoaded = FALSE;
		for (int i=0; i< FRAME_WIMDOW_WIDTH_COUNT; i++)
			for (int j=0; j< FRAME_WIMDOW_HEIGHT_COUNT; j++)
				SliceLoaded[i][j] = -1;
	}

	~ScreenFrame(){;};

private:
	int Width;
	int Height;

	int SliceWidth;
	int SliceHeight;


	int OffsetX;
	int OffsetY;

	BOOL isLoaded;

public:
	int SliceLoaded[FRAME_WIMDOW_WIDTH_COUNT][FRAME_WIMDOW_HEIGHT_COUNT];
	CPicture bmp[FRAME_WIMDOW_WIDTH_COUNT][FRAME_WIMDOW_HEIGHT_COUNT];

public:
	bool MoveFrame(CDC* pDC, int x, int y);
	bool LoadSlice( CPicture *bmp, int nX, int nY);

	bool LoadFrame( int nX, int nY, int cX, int cY);
	bool DrawFrames(CDC* pDC, int offsetX, int offsetY);

};


#endif
